unit fGMV_DeviceSelector;
{
================================================================================
*
*       Application:  Vitals
*       Revision:     $Revision: 1 $  $Modtime: 1/13/05 3:38p $
*       Developer:    dan.petit@med.va.gov
*       Site:         Hines OIFO
*
*       Description:  Form for selecting a kernel device in applications
*
*       Notes:
*
================================================================================
*       $Archive: /Vitals/Vitals GUI  v 5.0.2.1 -5.0.3.1 - Patch GMVR-5-7 (CASMed, CCOW) - Delphi 6/VitalsManager-503/fGMV_DeviceSelector.pas $
*
* $History: fGMV_DeviceSelector.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/24/05    Time: 4:56p
 * Created in $/Vitals/Vitals GUI  v 5.0.2.1 -5.0.3.1 - Patch GMVR-5-7 (CASMed, CCOW) - Delphi 6/VitalsManager-503
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/16/04    Time: 4:21p
 * Created in $/Vitals/Vitals GUI Version 5.0.3 (CCOW, CPRS, Delphi 7)/VITALSMANAGER-503
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/26/04    Time: 1:06p
 * Created in $/Vitals/Vitals GUI Version 5.0.3 (CCOW, Delphi7)/V5031-D7/Common
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 10/29/03   Time: 4:14p
 * Created in $/Vitals503/Common
 * Version 5.0.3
 * 
 * *****************  Version 4  *****************
 * User: Vhaishandria Date: 7/18/02    Time: 5:57p
 * Updated in $/Vitals GUI Version 5.0/Common
 * 
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 7/12/02    Time: 5:01p
 * Updated in $/Vitals GUI Version 5.0/Common
 * GUI Version T28
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 7/05/02    Time: 3:49p
 * Updated in $/Vitals GUI Version 5.0/Common
 *
 * *****************  Version 1  *****************
 * User: Vhaishpetitd Date: 5/15/02    Time: 12:12p
 * Created in $/Vitals GUI Version 5.0/Common
 * Initial check-in
 *
 *
*
================================================================================
}

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
//  TRPCB,
  Forms,
  u_Common,
  Dialogs,
  StdCtrls,
  ComCtrls,
  mGMV_Lookup;

type
  TfrmGMV_DeviceSelector = class(TForm)
    fraDevice: TfraGMV_Lookup;
    lblDevice: TLabel;
    dtpDate: TDateTimePicker;
    dtpTime: TDateTimePicker;
    Label1: TLabel;
    btnCancel: TButton;
    btnOK: TButton;
    procedure FormCreate(Sender: TObject);
    procedure fraDeviceExit(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure dtpTimeChange(Sender: TObject);
    procedure dtpDateChange(Sender: TObject);
  private
    fDeviceString: string;
    fQueueDateTime: Double;
    CurrentTime: TDateTime;
  public
    { Public declarations }
  end;

  TFMDateTime = Double;

//function GetKernelDevice(Broker: TRPCBroker; var DeviceString: string; var QueueDateTime: TFMDateTime): Boolean;
function GetKernelDevice(var DeviceString: string; var QueueDateTime: TFMDateTime): Boolean;

implementation

uses uGMV_User;

{$R *.DFM}

//function GetKernelDevice(Broker: TRPCBroker; var DeviceString: string; var QueueDateTime: TFMDateTime): Boolean;
function GetKernelDevice(var DeviceString: string; var QueueDateTime: TFMDateTime): Boolean;
begin
  with TfrmGMV_DeviceSelector.Create(Application) do
    try
//      fraDevice.InitFrame(Broker, '3.5', GMVUser.Setting[usLastVistAPrinter]);
      fraDevice.InitFrame('3.5', GMVUser.Setting[usLastVistAPrinter]);
      btnOK.Enabled := (fraDevice.IEN <> '');
      Result := (ShowModal = mrOK);
      if Result then
        begin
          DeviceString := fDeviceString;
          QueueDateTime := fQueueDateTime;
        end;
    finally
      free;
    end;
end;

procedure TfrmGMV_DeviceSelector.FormCreate(Sender: TObject);
begin
  CurrentTime := Now;
  dtpDate.DateTime := CurrentTime;
  dtpDate.MinDate := trunc(CurrentTime);
  dtpTime.DateTime := CurrentTime;
end;

procedure TfrmGMV_DeviceSelector.fraDeviceExit(Sender: TObject);
begin
  fraDevice.FrameExit(Sender);
  btnOK.Enabled := (fraDevice.IEN <> '');
  btnOK.Default := (btnOk.Enabled);
end;

procedure TfrmGMV_DeviceSelector.btnOKClick(Sender: TObject);
begin
  GMVUser.Setting[usLastVistaPrinter] := fraDevice.IEN;
  fDeviceString := fraDevice.edtValue.Text;
  {Code to later add the subtype and iom/iosl
     + ';' +
    GetFMData(GMVBroker, '3.5', fraDevice.IENS, '3') + ';' +
    GetFMData(GMVBroker, '3.5', fraDevice.IENS, '9') + ';' +
    GetFMData(GMVBroker, '3.5', fraDevice.IENS, '11');
   }
  fQueueDateTime := WindowsDateTimeToFMDateTime(trunc(dtpDate.Date) + (dtpTime.Time - trunc(dtpTime.Date)));
  ModalResult := mrOK;
end;

procedure TfrmGMV_DeviceSelector.dtpTimeChange(Sender: TObject);
begin
  if trunc(dtpDate.Date) + frac(dtpTime.Time) < CurrentTime then
    dtpTime.DateTime := CurrentTime;
end;

procedure TfrmGMV_DeviceSelector.dtpDateChange(Sender: TObject);
begin
  try
    if dtpDate.DateTime < CurrentTime then
      dtpDate.DateTime := CurrentTime;
  except
  end;
end;

end.

